// Highlight Element
import { browser, element, by } from 'protractor';
import { Highlighter } from '../src/highlighter';

const EC = require('protractor').ExpectedConditions;
const usernameField = element(by.id('username'));
const passwordField = element(by.id('password'));
const loginButton = element(by.css('[class=radius]'));
const headerLabel = element(by.css('[class="example"] h2'));
const logoutButton = element(by.css('[class="button secondary radius"]'));
const successLoginLabel = element(by.css('[class="flash success"]'));
const timeout = 600 * 1000;
const dreamTime = 1 * 1000;
const highlighter = new Highlighter();
const duration = 2;

describe('"the-internet" Protractor DEMO', ()=> {
  it('should navigate to login page', () => {
    browser.get('http://localhost:9292/login');
    browser.wait(EC.presenceOf(headerLabel));
    
    highlighter.highlightElement(headerLabel, duration);
    expect(headerLabel.getText()).toBe('Login Page');
  }, timeout);

  it('should login with user and password', () => {
    browser.wait(EC.presenceOf(usernameField));

    highlighter.highlightElement(usernameField, duration);
    usernameField.sendKeys('tomsmith');
    highlighter.highlightElement(passwordField, duration);
    passwordField.sendKeys('SuperSecretPassword!');

    highlighter.highlightElement(loginButton, duration);
    loginButton.click();
    
    highlighter.highlightElement(successLoginLabel, duration);
    expect(successLoginLabel.isPresent()).toBe(true);
  }, timeout);

  it('should logout', () => {
    browser.sleep(dreamTime);

    highlighter.highlightElement(logoutButton, duration);
    logoutButton.click();

    highlighter.highlightElement(headerLabel, duration);
    expect(headerLabel.getText()).toBe('Login Page');
  }, timeout)
});
